summaryrefslogtreecommitdiffstats
path: root/libexec
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-06-06 13:57:35 +0000
committerDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-06-29 11:19:35 +0000
commit2e67a52c2e1a25ce7b5a1b4e79bf31799079ae67 (patch)
tree205c303809658619addf0ec15b6f816b9a1b89aa /libexec
parentUsing cnt run to determine IP addresses in container list. (diff)
downloadcompute-tools-2e67a52c2e1a25ce7b5a1b4e79bf31799079ae67.tar.xz
compute-tools-2e67a52c2e1a25ce7b5a1b4e79bf31799079ae67.zip
Adding initial container info command.
Signed-off-by: Daniel Baumann <daniel.baumann@open-infrastructure.net>
Diffstat (limited to 'libexec')
-rwxr-xr-xlibexec/container/info214
1 files changed, 214 insertions, 0 deletions
diff --git a/libexec/container/info b/libexec/container/info
new file mode 100755
index 0000000..63c42ff
--- /dev/null
+++ b/libexec/container/info
@@ -0,0 +1,214 @@
+#!/bin/sh
+
+# Copyright (C) 2014-2021 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+PROJECT="open-infrastructure"
+SOFTWARE="compute-tools"
+PROGRAM="container"
+COMMAND="$(basename ${0})"
+
+CONFIG="/etc/${SOFTWARE}/config"
+HOOKS="/etc/${SOFTWARE}/hooks"
+MACHINES="/var/lib/machines"
+
+VERSION="$(${PROGRAM} version)"
+
+Parameters ()
+{
+ GETOPT_LONGOPTIONS="name:,status,os,ip,"
+ GETOPT_OPTIONS="n:,"
+
+ PARAMETERS="$(getopt --longoptions ${GETOPT_LONGOPTIONS} --name=${COMMAND} --options ${GETOPT_OPTIONS} --shell sh -- ${@})"
+
+ if [ "${?}" != "0" ]
+ then
+ echo "'${COMMAND}': getopt exit" >&2
+ exit 1
+ fi
+
+ eval set -- "${PARAMETERS}"
+
+ while true
+ do
+ case "${1}" in
+ -n|--name)
+ NAME="${2}"
+ shift 2
+ ;;
+
+ --status)
+ ACTIONS="${ACTIONS} status"
+ shift 1
+ ;;
+
+ --os)
+ ACTIONS="${ACTIONS} os"
+ shift 1
+ ;;
+
+ --ip)
+ ACTIONS="${ACTIONS} ip"
+ shift 1
+ ;;
+
+ --)
+ shift 1
+ break
+ ;;
+
+ *)
+ echo "'${COMMAND}': getopt error" >&2
+ exit 1
+ ;;
+ esac
+ done
+}
+
+Usage ()
+{
+ echo "Usage: ${PROGRAM} ${COMMAND} -n|--name NAME [--status] [--os] [--ip]" >&2
+ exit 1
+}
+
+Parameters "${@}"
+
+# Pre hooks
+for FILE in "${HOOKS}/pre-${COMMAND}".* "${HOOKS}/${NAME}.pre-${COMMAND}"
+do
+ if [ -x "${FILE}" ]
+ then
+ "${FILE}"
+ fi
+done
+
+ACTIONS="${ACTIONS:-status os ip}"
+HOST="$(cat /etc/hostname)"
+
+# Run
+
+# Status
+STATUS="$(machinectl show ${NAME} 2>&1 | awk -FState= '/^State=/ { print $2 }')"
+
+if [ -e "${CONFIG}/${NAME}.conf" ]
+then
+ CONTAINER_SERVER="$(awk -Fcnt.container-server= '/^cnt.container-server=/ { print $2 }' ${CONFIG}/${NAME}.conf)"
+ CONTAINER_SERVER="${CONTAINER_SERVER:-false}"
+
+ case "${CONTAINER_SERVER}" in
+ ${HOST}|true)
+ ;;
+
+ *)
+ STATUS="other"
+ ;;
+ esac
+else
+ STATUS="other"
+fi
+
+case "${STATUS}" in
+ running)
+ STATUS="started"
+ ;;
+
+ other)
+ ;;
+
+ *)
+ STATUS="stopped"
+ ;;
+esac
+
+# OS
+VERSION_BASH="$(chroot ${MACHINES}/${NAME} apt-cache policy bash | awk '/Installed: / { print $2 }')"
+
+case "${VERSION_BASH}" in
+ 4.1*)
+ OS="Debian 6 (squeeze)"
+ ;;
+
+ 4.2*)
+ OS="Debian 7 (wheezy)"
+ ;;
+
+ 4.3*)
+ OS="Debian 8 (jessie)"
+ ;;
+
+ 4.4*)
+ OS="Debian 9 (stretch)"
+ ;;
+
+ 5.0*)
+ OS="Debian 10 (buster)"
+ ;;
+
+ 5.1*)
+ OS="Debian 11 (bullseye)"
+ ;;
+
+ *)
+ OS="n/a"
+ ;;
+esac
+
+case "${STATUS}" in
+ started)
+ IP="$(cnt run -n ${NAME} -- hostname -I | awk '{ print $1 }')"
+ ;;
+
+ *)
+ if ls "${MACHINES}/${CONTAINER}/etc/systemd/network"/*.network > /dev/null 2>&1
+ then
+ IP="$(awk -FAddress= '/^Address/ { print $2 }' ${MACHINES}/${CONTAINER}/etc/systemd/network/*.network | head -n1)"
+ elif [ -e "${MACHINES}/${CONTAINER}/etc/network/interfaces" ]
+ then
+ IP="$(awk '/address/ { print $2 }' ${MACHINES}/${CONTAINER}/etc/network/interfaces | head -n1)"
+ fi
+
+ IP="${IP:-n/a}"
+ ;;
+esac
+
+for ACTION in ${ACTIONS}
+do
+ case "${ACTION}" in
+ status)
+ echo "${STATUS}"
+ ;;
+
+ os)
+ echo "${OS}"
+ ;;
+
+ ip)
+ echo "${IP}"
+ ;;
+ esac
+done
+
+# Post hooks
+for FILE in "${HOOKS}/post-${COMMAND}".* "${HOOKS}/${NAME}.post-${COMMAND}"
+do
+ if [ -x "${FILE}" ]
+ then
+ "${FILE}"
+ fi
+done